<template>
  <v-select
    :readonly="readonly"
    :label="label"
    :items="banks"
    item-value="id"
    item-text="unit_name"
    :hide-no-data="!search"
    v-model="selectedValue"
    clearable
    :hint="hint"
    :search-input.sync="search"
    @keyup="load(search, $event)"
    @change="$emit('change')"
    :rules="rules"
  />
</template>

<script lang="ts">
import { Component, Vue, Prop } from 'vue-property-decorator'
import api from '../../plugins/api'

@Component({ components: {} })
export default class BankSelect extends Vue {
  @Prop({ required: true }) value!: string
  @Prop({ default: false }) readonly!: boolean
  @Prop({ default: 'Arka/Banka' }) label!: string
  rules: any = [(value: any) => !!value || 'Fusha nuk mund të lihet bosh']
  banks: Array<any> = []
  search?: string = ''
  hint?: string = 'banka'
  public get selectedValue() {
    return this.value
  }
  public set selectedValue(newValue) {
    this.$emit('input', newValue)
    this.$emit('change', newValue)
    const newBank = this.banks.find(i => i.id === newValue)
    if (newBank) {
      this.$emit('selected', newBank.unit_name)
    }
  }
  mounted() {
    this.fetch()
  }
  fetch() {
    api()
      .get('api/account-management/banks?resource=CashUnitsSelectResource')
      .then(response => {
        this.banks = response.data.data
      })
  }
}
</script>
